﻿using System.Collections.ObjectModel;
using System.Windows;
using Data;
using C1.WPF.FlexGrid;
using System.Windows.Controls;

namespace ConvertWPF.Views
{
    /// <summary>
    ///     Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            c1FlexGrid.CellFactory = new CustomCellFactory();
            DataContext = new MainViewModel();
            
        }
    }

    public class MainViewModel : NotificationObject
    {
        private ObservableCollection<JournalMainteModel> journalMainteModels = new ObservableCollection<JournalMainteModel>();

        public MainViewModel()
        {
            #region Create sample data

            JournalMainteModels.Add(new JournalMainteModel
            {
                Code = "Code",
                Label = "Label",
                Description = "Description",
                HasErrors = true
            });

            JournalMainteModels.Add(new JournalMainteModel
            {
                Code = "Code 1",
                Label = "Label 1",
                Description = "Description 1",
                HasErrors = true
            });
            var journalMainteModel1 = new JournalMainteModel
            {
                Code = "Code 3",
                Label = "Label 3",
                Description = "Description 2"
            };

            journalMainteModel1.JournalTermModels.Add(new JournalMainteModel
            {
                Code = "Child Code 4",
                Label = "Child Name 4",
                Description = "Child Description 1"
            });

            journalMainteModel1.JournalTermModels.Add(new JournalMainteModel
            {
                Code = "Child Code 5",
                Label = "Child Name 5",
                Description = "Child Description 2"
            });

            var journalMainteModel = new JournalMainteModel
            {
                Code = "Code 2",
                Label = "Label 2",
                Description = "Description 2"
            };

            journalMainteModel.JournalTermModels.Add(new JournalMainteModel
            {
                Code = "Child Code 1",
                Label = "Child Name 1",
                Description = "Child Description 1"
            });

            journalMainteModel.JournalTermModels.Add(new JournalMainteModel
            {
                Code = "Child Code 2",
                Label = "Child Name 2",
                Description = "Child Description 2"
            });

            JournalMainteModels.Add(journalMainteModel);
            JournalMainteModels.Add(journalMainteModel1);

            #endregion
        }

        public ObservableCollection<JournalMainteModel> JournalMainteModels
        {
            get { return journalMainteModels; }
            set
            {
                journalMainteModels = value;
                RaisePropertyChanged(() => JournalMainteModels);
            }
        }
    }

    public class CustomCellFactory : CellFactory
    {

        Border mainBdr = null;
        public override void CreateCellContent(C1FlexGrid grid, Border bdr, CellRange range)
        {
            // use default implementation
            base.CreateCellContent(grid, bdr, range);

            var gr = grid.Rows[range.Row] as GroupRow;

            // if row is GroupRow
            if (gr != null && gr.HasChildren)
            {
                Grid grd = bdr.Child as Grid;
                if (range.Column == 0)
                {
                    mainBdr = grd.Children[0] as Border;
                    grd.Children.RemoveAt(0);
                    Border newbdr = new Border();
                    newbdr.Padding = mainBdr.Padding;
                    newbdr.RenderSize = bdr.RenderSize;
                    newbdr.Margin = bdr.Margin;
                    newbdr.Height = bdr.ActualHeight;
                    newbdr.Width = 5;
                    grd.VerticalAlignment = VerticalAlignment.Center;
                    grd.Children.Insert(0, newbdr);

                }
                if (range.Column == 1)
                {
                    if (grd == null)
                    {
                        try
                        {
                            grd = new Grid();
                            TextBlock tb = bdr.Child as TextBlock;
                            bdr.Child = null;
                            //grd.Children.Add(tb);
                            StackPanel sp = new StackPanel();
                            sp.Orientation = Orientation.Horizontal;                          
                            sp.Children.Add(mainBdr);
                            sp.Children.Add(tb);
                            grd.Children.Insert(0, sp);
                            bdr.Child = grd;
                        }
                        catch { }
                    }

                }
            }
            if (gr != null && gr.HasChildren == false)
            {
                Grid grd = bdr.Child as Grid;
                if (range.Column == 0)
                {
                    grd.Margin = new Thickness(0);
                    mainBdr = grd.Children[0] as Border;
                    grd.Children.RemoveAt(0);
                    grd.VerticalAlignment = VerticalAlignment.Center;
                    bdr.Padding = new Thickness(5,0,0,0);
                }
            }
        }
    }
}